=== debian/control ===
Source: mergerfs
Section: utils
Priority: optional
Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~),
 libattr1-dev
Standards-Version: 4.6.1
Rules-Requires-Root: binary-targets
Homepage: https://github.com/trapexit/mergerfs
Vcs-Git: https://salsa.debian.org/debian/mergerfs.git
Vcs-Browser: https://salsa.debian.org/debian/mergerfs

Package: mergerfs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 fuse3 (>= 3.10.1-3) | fuse (<< 3)
Description: another FUSE union filesystem
 mergerfs is a union filesystem geared towards simplifying storage and
 management of files across numerous commodity storage devices. It is
 similar to mhddfs, unionfs, and aufs.
 .
 Some salient features include
  * Runs in userspace (FUSE)
  * Configurable behaviors
  * Support for extended attributes (xattrs)
  * Support for file attributes (chattr)
  * Runtime configurable (via xattrs)
  * Safe to run as root
  * Opportunistic credential caching
  * Works with heterogeneous filesystem types
  * Handling of writes to full drives
  * Handles pool of readonly and read/write drives
